package com.jclark.xml.parse;

import com.jclark.util.Hashtable;

class ElementType {
  ElementType() { }

  void setElementContent(boolean b) {
    elementContent = b;
  }

  boolean isElementContent() {
    return elementContent;
  }

  int getDefaultAttributeCount() {
    return nDefaultAtts;
  }

  int getAttributeDefaultIndex(String name) {
    Integer i = (Integer)nameIndexTable.get(name);
    return i == null ? -1 : i.intValue();
  }

  String getDefaultAttributeValue(int i) {
    if (i >= nDefaultAtts)
      throw new IndexOutOfBoundsException();
    return defaultAttValues[i];
  }

  String getDefaultAttributeName(int i) {
    if (i >= nDefaultAtts)
      throw new IndexOutOfBoundsException();
    return defaultAttNames[i];
  }

  boolean isAttributeCdata(String name) {
    return nonCdataAttTable.get(name) == null;
  }

  /* Value may be null if the default is #IMPLIED or #REQUIRED. */
  void appendAttribute(String name, String value, boolean isCdata) {
    if (nameIndexTable.get(name) == null) {
      if (value == null)
	nameIndexTable.put(name, new Integer(-1));
      else {
	if (nDefaultAtts == defaultAttNames.length) {
	  defaultAttNames = grow(defaultAttNames);
	  defaultAttValues = grow(defaultAttValues);
	}
	defaultAttNames[nDefaultAtts] = name;
	defaultAttValues[nDefaultAtts] = value;
	nameIndexTable.put(name, new Integer(nDefaultAtts++));
      }
      if (!isCdata)
	nonCdataAttTable.put(name, name);
    }
  }

  private final Hashtable nameIndexTable = new Hashtable();
  private final Hashtable nonCdataAttTable = new Hashtable();
  private int nDefaultAtts = 0;
  private String[] defaultAttNames = new String[4];
  private String[] defaultAttValues = new String[4];
  private boolean elementContent = false;

  private static final String[] grow(String[] v) {
    String[] tem = v;
    v = new String[tem.length << 1];
    System.arraycopy(tem, 0, v, 0, tem.length);
    return v;
  }
}
